#define GEISTERDATABASE_C

#include "Geisterdatabase.h"
#include "geisterlib.h"
#include <stdbool.h>
#include <time.h>

int GstPatternMatching(struct GstGameStr *s, struct GstActionStr *a, struct GstPatternStr *b){
    /*
        is this ok?
        "diff" is not used, should write again more simple code. 
    */

    int diff;
    struct GstPatternStr *cur=b;
    for(int i=0;i<NumPattern;i++,cur++){
        diff=0;
        for(int j=0;j<GstBdW;j++){
            for(int k=0;k<GstBdH;k++){
                int exist,player=0,color=0;
                if(s->board[j][k]==NULL) exist=FALSE;
                else {
                    exist=TRUE;
                    player=s->board[j][k]->player;
                    color=s->board[j][k]->color;
                }
                switch(cur->board[j][k]){
                    case GstPly0b:if(exist!=TRUE||player!=GstPly0||color!=GstBlue) {
                            if(exist==TRUE&&player==GstPly0&&color!=GstBlue) diff+=5;
                            if(exist==FALSE) diff+=7;
                            if(exist==TRUE&&player==GstPly1) diff+=11;
                            break;
                        } 
                    case GstPly0g:if(exist!=TRUE||player!=GstPly0) {
                            if(exist==FALSE) diff+=6;
                            else diff+=10;
                            break;
                        }
                    case GstPly1g:if(exist!=TRUE||player!=GstPly1) {
                            if(exist==TRUE&&player==GstPly0&&color==GstBlue) diff+=1;
                            if(exist==TRUE&&player==GstPly0&&color!=GstBlue) diff+=2;
                            if(exist==FALSE) diff+=4;
                            break;
                        }
                    case GstPly0n:if((exist==TRUE)&&(player!=GstPly0)) {
                            diff+=8;
                            break;
                        }
                    default: break;
                }
            }
        }
        if  (diff==0&&s->capturecount[GstPly1][GstRed]<=4-cur->restRed){a->ghost=s->board[cur->x][cur->y];a->dir=cur->dir;return TRUE;}
    }
    return FALSE;
}

int GstBlockEscape(struct GstGameStr *s, struct GstActionStr *a, struct GstPatternStr *b){
    struct GstShortestStr dist[2][2]; // 2player*left,right
    int x,y,i,j;

    // search the victory pattern
  for(i=0;i<2;i++)
    for(j=0;j<2;j++)
      dist[i][j].ManhattanDist=99; // all pattern distance to exit set infinite value

  // search nearest ghost to each exit
  for(i=0;i<8;i++){ 
    if(s->ghost[GstPly1][i].state!=GstCaptured){  
    x=s->ghost[GstPly1][i].x;
    y=s->ghost[GstPly1][i].y;
    if(x==-1) continue;
    if((x+y)<dist[GstPly1][GstWestExit].ManhattanDist){
      dist[GstPly1][GstWestExit].ManhattanDist=(x+5-y);
      dist[GstPly1][GstWestExit].ghost=&(s->ghost[GstPly1][i]);
      dist[GstPly1][GstWestExit].y=y;
    }
    if((5+y-x)<dist[GstPly1][GstEastExit].ManhattanDist){
      dist[GstPly1][GstEastExit].ManhattanDist=(10-y-x);
      dist[GstPly1][GstEastExit].ghost=&(s->ghost[GstPly1][i]);
      dist[GstPly1][GstEastExit].y=y;
    }
  }}
  for(i=0;i<8;i++){
    if(s->ghost[GstPly0][i].state!=GstCaptured){
    x=s->ghost[GstPly0][i].x;
    y=s->ghost[GstPly0][i].y;
    if(x==-1) continue;
    if((x+y)<dist[GstPly0][GstWestExit].ManhattanDist){
      dist[GstPly0][GstWestExit].ManhattanDist=(x+5-y);
      dist[GstPly0][GstWestExit].ghost=&(s->ghost[GstPly0][i]);
    }
    if((5+y-x)<dist[GstPly0][GstWestExit].ManhattanDist){
      dist[GstPly0][GstEastExit].ManhattanDist=(10-y-x);
      dist[GstPly0][GstEastExit].ghost=&(s->ghost[GstPly0][i]);
    }
  }}
  // if AI's ghost can escape singularity, act to escape
  if(dist[GstPly1][GstWestExit].ManhattanDist<dist[GstPly0][GstWestExit].ManhattanDist){
    return TRUE;
  }
  if(dist[GstPly1][GstEastExit].ManhattanDist<dist[GstPly0][GstEastExit].ManhattanDist){
     return TRUE;
  } 
 
  // execute patternmatching
  //if(GstPatternMatching(s,a,b)) return TRUE;

  return FALSE;
}

int GstColorInference(struct GstGameStr *s,int first,int *color_inf,float *red_th,float *blue_th,float *confidence, struct GstActionStr *a_opp,int cap){
    float r1;
    int r2,r3;
    
    if(first==TRUE){
        

        // set opponent's color by using place of on-board ghost.
        for(int i=0;i<8;i++){if(s->ghost[GstPly1][i].state!=GstCaptured){
        
            if(s->ghost[GstPly1][i].x==0||s->ghost[GstPly1][i].x==5){
                if(s->ghost[GstPly1][i].y<=2){confidence[i]+=0.1;}
                else if(s->ghost[GstPly1][i].y<=3){confidence[i]+=0.2;}
                else if(s->ghost[GstPly1][i].y<=4){confidence[i]+=0.3;}
                else {confidence[i]+=0.7;}
            }
            else if(s->ghost[GstPly1][i].x==1||s->ghost[GstPly1][i].x==4){
                if(s->ghost[GstPly1][i].y<=3){confidence[i]+=0.1;}
                else if(s->ghost[GstPly1][i].y<=4){confidence[i]+=0.2;}
                else {confidence[i]+=0.3;}
            }
            else if(s->ghost[GstPly1][i].x==2||s->ghost[GstPly1][i].x==3){
                if(s->ghost[GstPly1][i].y<=2){}
                else if(s->ghost[GstPly1][i].y<=3){confidence[i]-=0.1;}
                else if(s->ghost[GstPly1][i].y<=4){confidence[i]+=0.1;}
                else {confidence[i]+=0.2;}
            }

            r3=rand()%11;
            r1=(float)r3;
            r2=rand()%2;
            if(r2==0)confidence[i]+=r1/100;
            else confidence[i]-=r1/100;
        }}

        float max1=-99.9,max2=-99.9,min1=99.9,min2=99.9;
        int n1=0,n2,m1=0,m2;
        for(int i=0;i<8;i++){
            if(s->ghost[GstPly1][i].state!=GstCaptured){
                if(confidence[i]>max1){max2=max1;n2=n1;max1=confidence[i],n1=i;}
                else if(confidence[i]>max2){max2=confidence[i];n2=i;}

                if(confidence[i]<min1){min2=min1;m2=m1;min1=confidence[i],m1=i;}
                else if(confidence[i]<min2){min2=confidence[i];m2=i;} 
            }
        
        }



        color_inf[n1]=GstBlue;
        if(s->capturecount[GstPly1][GstBlue]<=2) color_inf[n2]=GstBlue;
        color_inf[m1]=GstRed; 
        if(s->capturecount[GstPly1][GstRed]<=2) color_inf[m2]=GstRed;

/*
        for(int i=0;i<8;i++){
            
            if(confidence[i]>=*blue_th){color_inf[i]=GstBlue;}
            else if(confidence[i]<=*red_th){color_inf[i]=GstRed;}
            
           if((blue_th[i]-confidence[i])>(confidence[i]-red_th[i]))color_inf[i]=GstRed;
           else color_inf[i]=GstBlue;
        }
*/

    }else{
        if(cap==TRUE){
            // reset inference result
            for(int i=0;i<8;i++){
                blue_th[i]=1.0;
                red_th[i]=-1.0;

                float max1=-99.9,max2=-99.9,min1=99.9,min2=99.9;
                int n1=0,n2,m1=0,m2;
            for(int i=0;i<8;i++){
                if(s->ghost[GstPly1][i].state!=GstCaptured){
                    if(confidence[i]>max1){max2=max1;n2=n1;max1=confidence[i],n1=i;}
                    else if(confidence[i]>max2){max2=confidence[i];n2=i;}

                    if(confidence[i]<min1){min2=min1;m2=m1;min1=confidence[i],m1=i;}
                    else if(confidence[i]<min2){min2=confidence[i];m2=i;} 
                }
            }
                color_inf[n1]=GstBlue;
                if(s->capturecount[GstPly1][GstBlue]<=2) color_inf[n2]=GstBlue;
                color_inf[m1]=GstRed; 
                if(s->capturecount[GstPly1][GstRed]<=2) color_inf[m2]=GstRed;
            }
        }

        // inference opponent's color
        for(int i=0;i<8;i++){if(s->ghost[GstPly1][i].state!=GstCaptured){
            if(&(s->ghost[GstPly1][i])==a_opp->ghost){
                int NumVerging=0;
                for(int j=0;j<4;j++){
                    if(j==0){if(s->ghost[GstPly1][i].y!=0){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y-1]!=NULL){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y-1]->player==GstPly0)NumVerging++;}}}
                    else if(j==1){if(s->ghost[GstPly1][i].y!=5){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y+1]!=NULL){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y+1]->player==GstPly0)NumVerging++;}}}
                    else if(j==2){if(s->ghost[GstPly1][i].x!=0){if(s->board[s->ghost[GstPly1][i].x-1][s->ghost[GstPly1][i].y]!=NULL){if(s->board[s->ghost[GstPly1][i].x-1][s->ghost[GstPly1][i].y]->player==GstPly0)NumVerging++;}}}
                    else {if(s->ghost[GstPly1][i].x!=5){if(s->board[s->ghost[GstPly1][i].x+1][s->ghost[GstPly1][i].y]!=NULL){if(s->board[s->ghost[GstPly1][i].x+1][s->ghost[GstPly1][i].y]->player==GstPly0)NumVerging++;}}}
                }
                r3=rand()%11;
                r1=(float)r3;
                if(NumVerging==0) blue_th[i]-=r1/25;
                else red_th[i]+=((float)NumVerging/10.0)+(r1/25); 
                
                if(s->ghost[GstPly1][i].x==0||s->ghost[GstPly1][i].x==5){
                    if(s->ghost[GstPly1][i].y<=2){confidence[i]+=0.02;}
                    else if(s->ghost[GstPly1][i].y<=3){confidence[i]+=0.04;}
                    else if(s->ghost[GstPly1][i].y<=4){confidence[i]+=0.06;}
                    else {confidence[i]+=0.14;}
                }
                else if(s->ghost[GstPly1][i].x==1||s->ghost[GstPly1][i].x==4){
                    if(s->ghost[GstPly1][i].y<=3){confidence[i]+=0.02;}
                    else if(s->ghost[GstPly1][i].y<=4){confidence[i]+=0.04;}
                    else {confidence[i]+=0.06;}
                }
                else if(s->ghost[GstPly1][i].x==2||s->ghost[GstPly1][i].x==3){
                    if(s->ghost[GstPly1][i].y<=2){}
                    else if(s->ghost[GstPly1][i].y<=3){confidence[i]-=0.02;}
                    else if(s->ghost[GstPly1][i].y<=4){confidence[i]+=0.02;}
                    else {confidence[i]+=0.04;}
                }
                r3=rand()%11;
                r1=(float)r3;
                r2=rand()%2;
                if(r2==0)confidence[i]+=r1/200;
                else confidence[i]-=r1/200; 
            }
            else{ 
                int NumVerging=0;
                for(int j=0;j<4;j++){
                    if(j==0){if(s->ghost[GstPly1][i].y!=0){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y-1]!=NULL){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y-1]->player==GstPly0)NumVerging++;}}}
                    else if(j==1){if(s->ghost[GstPly1][i].y!=5){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y+1]!=NULL){if(s->board[s->ghost[GstPly1][i].x][s->ghost[GstPly1][i].y+1]->player==GstPly0)NumVerging++;}}}
                    else if(j==2){if(s->ghost[GstPly1][i].x!=0){if(s->board[s->ghost[GstPly1][i].x-1][s->ghost[GstPly1][i].y]!=NULL){if(s->board[s->ghost[GstPly1][i].x-1][s->ghost[GstPly1][i].y]->player==GstPly0)NumVerging++;}}}
                    else {if(s->ghost[GstPly1][i].x!=5){if(s->board[s->ghost[GstPly1][i].x+1][s->ghost[GstPly1][i].y]!=NULL){if(s->board[s->ghost[GstPly1][i].x+1][s->ghost[GstPly1][i].y]->player==GstPly0)NumVerging++;}}}
                }
                r3=rand()%11;
                r1=(float)r3;
                if(NumVerging!=0) red_th[i]+=((float)NumVerging/5.0)+(r1/25);

                r3=rand()%11;
                r1=(float)r3;
                if(s->ghost[GstPly1][i].x==0||s->ghost[GstPly1][i].x==5){
                    if(s->ghost[GstPly1][i].y<=2){blue_th[i]-=0.02+(r1/100);}
                    else if(s->ghost[GstPly1][i].y<=3){blue_th[i]-=0.04+(r1/100);}
                    else if(s->ghost[GstPly1][i].y<=4){blue_th[i]-=0.06+(r1/100);}
                    else {blue_th[i]-=0.14+(r1/100);}
                }
                else if(s->ghost[GstPly1][i].x==1||s->ghost[GstPly1][i].x==4){
                    if(s->ghost[GstPly1][i].y<=3){red_th[i]+=0.02+(r1/100);}
                    else if(s->ghost[GstPly1][i].y<=4){blue_th[i]-=0.04+(r1/100);}
                    else {blue_th[i]-=0.06+(r1/100);}
                }
                else if(s->ghost[GstPly1][i].x==2||s->ghost[GstPly1][i].x==3){
                    if(s->ghost[GstPly1][i].y<=2){}
                    else if(s->ghost[GstPly1][i].y<=3){red_th[i]+=0.02+(r1/100);}
                    else if(s->ghost[GstPly1][i].y<=4){blue_th[i]-=0.02+(r1/100);}
                    else {blue_th[i]-=0.04+(r1/100);}
                }

                r3=rand()%11;
                r1=(float)r3;
                r2=rand()%2;
                if(r2==0)confidence[i]+=r1/200;
                else confidence[i]-=r1/200; 
            }

            if(red_th[i]<-1.0) red_th[i]=-1.0;

            if(red_th[i]>blue_th[i]){
                red_th[i]=((red_th[i]+blue_th[i])/2.0);
                blue_th[i]=((red_th[i]+blue_th[i])/2.0);
            }
        }}
 
        for(int i=0;i<8;i++){
            if(color_inf[i]==GstRed){if(confidence[i]>=blue_th[i]) color_inf[i]=GstBlue;}
            else if(color_inf[i]==GstBlue){if(confidence[i]<=red_th[i]) color_inf[i]=GstRed;}
            else {if(confidence[i]<=red_th[i]) color_inf[i]=GstRed; if(confidence[i]>=blue_th[i]) color_inf[i]=GstBlue;}
        }

    }

    return TRUE;
}


int GstEvaluation(struct GstGameStr *s,struct GstPatternStr *b){
    int value=0,captured[2],capPlus=0,capMinus=0,Judge;
    captured[0]=0;captured[1]=0;
    struct GstActionStr *a;

    Judge=GstJudgeGame(s);
    if(Judge==GstWin) return 9999;
    else if(Judge==GstLose) return -9999;

    if(GstPatternMatching(s,a,b)) return 9999;

    if(s->capturecount[GstPly1][GstRed]<=2){
        if(GstBlockEscape(s,a,b)) a->ghost->color=GstBlue;
    }

    //calculate evaluated value
    for(int i=0;i<8;i++){
        if(s->ghost[GstPly0][i].state!=GstCaptured){
            if(s->ghost[GstPly0][i].color==GstBlue) value+=(5-s->ghost[GstPly0][i].y)*10;
            else value+=(5-s->ghost[GstPly0][i].y)*6;
            int dist1=s->ghost[GstPly0][i].x+s->ghost[GstPly0][i].y;
            int dist2=5-s->ghost[GstPly0][i].x+s->ghost[GstPly0][i].y;
            int dist=(dist1<dist2)?20-dist1*2:20-dist2*2;
        }else{
            if(s->ghost[GstPly0][i].color==GstBlue) value-=10;
            else value+=10;
        }
    }

    for(int i=0;i<8;i++){
        if(s->ghost[GstPly1][i].state!=GstCaptured){
            if(s->ghost[GstPly1][i].color==GstBlue) value+=(s->ghost[GstPly1][i].y)*3;
            else if(s->ghost[GstPly1][i].color==GstRed) value+=(s->ghost[GstPly1][i].y)*5;
            else value+=(s->ghost[GstPly1][i].y)*4;
        }else{
            if(s->capturecount[GstPly1][GstRed]<=3){
                if(s->ghost[GstPly1][i].color==GstBlue) value+=30;
                else if(s->ghost[GstPly1][i].color==GstRed) value+=10;
                else value+=20;
            }else{
                if(s->ghost[GstPly1][i].color==GstBlue) value+=5;
                else if(s->ghost[GstPly1][i].color==GstRed) value-=5;
            }
        }
    }
    return value;
}


int GstAlphaBeta(struct GstGameStr *s,bool my_turn,int depth,int alpha,int beta,double *passT,struct GstPatternStr *b,int *color_inf){
    int value,best_value;
    int best=-99;
    
    struct GstGameStr StateCopy,*s_cp,StateTemp,*s_tp;
    struct GstActionStr action, *a;
    s_tp=&StateTemp;
    s_cp=&StateCopy;
    a=&action;
    GstInitGame(s_cp);
    GstCopyGame(s_cp,s,0);
    
    /*
    best...Best move. best/10 shows ghost, best%10 shows dir. 
    my_turn...if now is my turn, it is TRUE. if now is opponent's turn, it is FALSE 
	depth...default value is 1.
	best_value...the best one in value.
	value...evaluated value or returned value from leafside node.
	alpha...AI side's smallest value. if opponent can choose lower number than alpha, stop searching game tree.
	beta...Opponent side's biggest value. if AI can choose bigger number than beta, stop searching game tree.
	*/

    if(depth-1==NumMovesOfSearch){
        return GstEvaluation(s_cp,b);
    }
    if(my_turn){
        if(depth==1){
            for(int i=0;i<8;i++){s_cp->ghost[GstPly1][i].color=color_inf[i];}
            //GstPrintGame(stdout,s_cp);
            //Sleep(1000);
        }
        best_value=-9999;
        for(int i=0;i<8;i++){
            if(s_cp->ghost[GstPly0][i].state!=GstCaptured&&s_cp->ghost[GstPly0][i].hiddenTruth!=FALSE){
                a->ghost=&(s_cp->ghost[GstPly0][i]);
                for(int j=0;j<4;j++){
                    switch(j){
                        case 0:{a->dir=GstWest;break;}
                        case 1:{a->dir=GstEast;break;}
                        case 2:{a->dir=GstNorth;break;}
                        case 3:{a->dir=GstSouth;break;}
                    }
                    if(s_cp->ghost[GstPly0][i].hiddenTruth==CapOnly){
                        if(j==0){if(a->ghost->x==0)continue; if(s_cp->board[a->ghost->x-1][a->ghost->y]==NULL) continue; if(s_cp->board[a->ghost->x-1][a->ghost->y]->player==GstPly1) continue;}
                        if(j==1){if(a->ghost->x==5)continue; if(s_cp->board[a->ghost->x+1][a->ghost->y]==NULL) continue; if(s_cp->board[a->ghost->x+1][a->ghost->y]->player==GstPly1) continue;}
                        if(j==2){if(a->ghost->y==0)continue; if(s_cp->board[a->ghost->x][a->ghost->y-1]==NULL) continue; if(s_cp->board[a->ghost->x][a->ghost->y-1]->player==GstPly1) continue;}
                        if(j==3){if(a->ghost->x==5)continue; if(s_cp->board[a->ghost->x][a->ghost->y+1]==NULL) continue; if(s_cp->board[a->ghost->x][a->ghost->y+1]->player==GstPly1) continue;}   
                    }
                    if(!GstCheckAction(s_cp,a)) continue;
                    //printf("Test board->my_turn?...%s depth...%d turn...%d alpha...%d beta...%d \n",my_turn?"true":"false",depth,s_cp->turn,alpha,beta);
                    //GstPrintGame(stdout,s_cp);
                    GstCopyGame(s_tp,s_cp,0);
                    GstExecAction(s_cp,a);

                    // Check the game is finish or not
                    int game=GstJudgeGame(s_cp);
                    if(game!=GstContinue){
                        //The game is finished
                        if(game==GstWin){
                            GstCopyGame(s_cp,s_tp,0);
                            best=i*10+j;
                            if(depth==1) return best;
                            return 9999;
                        }else{
                            GstCopyGame(s_cp,s_tp,0);
                            if(depth==1) return best;
                            return -9999;
                        }
                    }

                    value=GstAlphaBeta(s_cp,!my_turn,depth+1,alpha,beta,passT,b,color_inf);

                    if(value>=beta){GstCopyGame(s_cp,s_tp,0); if(depth==1) return best; return 9999;}
                    if(value>best_value){
                        best_value=value; best=i*10+j; alpha=best_value;
                    }

                    GstCopyGame(s_cp,s_tp,0);
                    //printf("Test board->my_turn?...%s depth...%d turn...%d alpha...%d beta...%d \n",my_turn?"true":"false",depth,s_cp->turn,alpha,beta);
                    //GstPrintGame(stdout,s_cp);
                }
            }
        }
        if(depth==1){
            
            return best;
        }
        else{return best_value;}

    }else{
        best_value=9999;
        
        for(int i=0;i<8;i++){
            if(s_cp->ghost[GstPly1][i].state!=GstCaptured){
                a->ghost=&(s_cp->ghost[GstPly1][i]);
                for(int j=0;j<4;j++){
                    switch(j){
                        case 0:{a->dir=GstWest;break;}
                        case 1:{a->dir=GstEast;break;}
                        case 2:{a->dir=GstNorth;break;}
                        case 3:{a->dir=GstSouth;break;}
                    }
                    if(!GstCheckAction(s_cp,a)) continue;
                    //printf("Test board->my_turn?...%s depth...%d turn...%d alpha...%d beta...%d \n",my_turn?"true":"false",depth,s_cp->turn,alpha,beta);
                    //GstPrintGame(stdout,s_cp);
                    GstCopyGame(s_tp,s_cp,0);
                    GstExecAction(s_cp,a);

                    // Check the game is finish or not
                    int game=GstJudgeGame(s_cp);
                    if(game!=GstContinue){
                        //The game is finished
                        if(game==GstWin){
                            GstCopyGame(s_cp,s_tp,0);
                            return 9999;
                        }else{
                            GstCopyGame(s_cp,s_tp,0);
                            best=i*10+j;
                            return -9999;
                        }
                    }

                    value=GstAlphaBeta(s_cp,!my_turn,depth+1,alpha,beta,passT,b,color_inf);

                    if(value<=alpha){GstCopyGame(s_cp,s_tp,0); return -9999;}
                    if(value<best_value){
                        best_value=value; best=i*10+j; beta=best_value;
                    }

                    GstCopyGame(s_cp,s_tp,0);
                    //printf("Test board->my_turn?...%s depth...%d turn...%d alpha...%d beta...%d \n",my_turn?"true":"false",depth,s_cp->turn,alpha,beta);
                    //GstPrintGame(stdout,s_cp);
                }
            }
        }
        if(depth==1){
            return best;
        }
        else{return best_value;}
        
    }


    return FALSE;
}


int GstPatternSet(struct GstPatternStr *b){
    struct GstPatternStr *cur,*temp;
    cur=b;

    // initialize all winning pattern 
    for(int i=0;i<NumPattern;i++,cur++){
        for(int j=0;j<GstBdW;j++)
            for(int k=0;k<GstBdH;k++)
                cur->board[j][k]=GstRegardless;
    }
    cur=b;

    /* later part is winning pattern list */

//////////////////////////////////////////////////////////////////////////////
    /*
        Template

        cur->board[x][y]=state;
        ...
        ...
        ...
        cur->x=num;
        cur->y=num;
        cur->dir=direction;
        cur->turn=num;
        cur->restRed=num;
        temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;
    */
/////////////////////////////////////////////////////////////////////////////////

    /* Pattern 1-1 */
    cur->board[0][0]=GstPly1g;
    cur->board[1][0]=GstPly0n;
    cur->board[0][1]=GstPly0b;
    cur->x=0;
    cur->y=1;
    cur->dir=GstNorth;
    cur->turn=2;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    /* Pattern 1-1-b */
    cur->board[0][0]=GstPly1g;
    cur->board[1][0]=GstPly0b;
    cur->board[0][1]=GstPly0n;
    cur->x=1;
    cur->y=0;
    cur->dir=GstWest;
    cur->turn=2;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    /* Pattern 1-2 */
    cur->board[0][0]=GstPly0g;
    cur->board[1][0]=GstPly1g;
    cur->board[2][0]=GstPly0n;
    cur->board[0][1]=GstPly0b;
    cur->board[1][1]=GstPly0n;
    cur->board[0][2]=GstPly0n;
    cur->x=0;
    cur->y=0;
    cur->dir=GstEast;
    cur->turn=3;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    /* Pattern 1-3 */
    cur->board[0][0]=GstPly0n;
    cur->board[1][0]=GstPly1g;
    cur->board[2][0]=GstPly0n;
    cur->board[0][1]=GstPly0b;
    cur->board[1][1]=GstPly0g;
    cur->board[0][2]=GstPly0n;
    cur->x=1;
    cur->y=1;
    cur->dir=GstNorth;
    cur->turn=3;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    /* Pattern 1-4 */
    cur->board[0][0]=GstPly0n;
    cur->board[1][0]=GstPly1g;
    cur->board[2][0]=GstPly0g;
    cur->board[0][1]=GstPly0b;
    cur->board[1][1]=GstPly0n;
    cur->board[0][2]=GstPly0n;
    cur->x=2;
    cur->y=0;
    cur->dir=GstWest;
    cur->turn=3;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    /* Pattern 1-2-b */
    cur->board[0][0]=GstPly0g;
    cur->board[1][0]=GstPly0b;
    cur->board[2][0]=GstPly0n;
    cur->board[0][1]=GstPly1g;
    cur->board[1][1]=GstPly0n;
    cur->board[0][2]=GstPly0n;
    cur->x=0;
    cur->y=0;
    cur->dir=GstSouth;
    cur->turn=3;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    /* Pattern 1-3-b */
    cur->board[0][0]=GstPly0n;
    cur->board[1][0]=GstPly0b;
    cur->board[2][0]=GstPly0n;
    cur->board[0][1]=GstPly1g;
    cur->board[1][1]=GstPly0g;
    cur->board[0][2]=GstPly0n;
    cur->x=1;
    cur->y=1;
    cur->dir=GstWest;
    cur->turn=3;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    /* Pattern 1-4-b */
    cur->board[0][0]=GstPly0n;
    cur->board[1][0]=GstPly0b;
    cur->board[2][0]=GstPly0n;
    cur->board[0][1]=GstPly1g;
    cur->board[1][1]=GstPly0n;
    cur->board[0][2]=GstPly0g;
    cur->x=0;
    cur->y=2;
    cur->dir=GstNorth;
    cur->turn=3;
    cur->restRed=2;
    temp=cur;
        cur++;
        for(int i=0;i<GstBdW;i++)
            for(int j=0;j<GstBdH;j++)
                cur->board[i][j]=temp->board[GstBdW-1-i][j];
        cur->x=GstBdW-1-temp->x;
        cur->y=temp->y;
        if(temp->dir==GstWest) cur->dir=GstEast;
        else if(temp->dir==GstEast) cur->dir=GstWest;
        else cur->dir=temp->dir;
        cur->turn=temp->turn;
        cur->restRed=temp->restRed;
        cur++;

    return TRUE;
}